dojo.declare("@iwName@Scope",null,{ 

    _uid: "",

    /*
     * The onLoad fuction is called when the widget is loaded it handles the following: 
     *     It sets up the unique id for the dijit.form.TextBox widget dataBox 
     *     It sets up the proxy URL for the image and sets it into the image.src 
     *     It calls dojo.parse to parse any dojo widgets in the html 
     */ 
	onLoad: function () {
       this._uid = this.iContext.getRootElement().getAttribute("id");
       console.debug("onLoad in @iwName@.js called root id = ",this._uid);

       try {
		  /* these lines are added to avoid duplicate ids for the dojo widget in case this iWidget is used more than once on a page */
          var widToUpdate = this.iContext.getElementById('@iwName@DataBox');
          widToUpdate.id = this._uid+"@iwName@DataBox";        
		} catch (e) {
			console.debug(e);
		}

       try {
		  /* these lines are added to show how to load an image remotely */		
		  var testimg = this.iContext.getElementById('@iwName@testimg');
		  var testimguri = this.iContext.io.rewriteURI("/iwidgets/@iwName@/images/testImage.png");
          console.debug("onLoad in @iwName@.js called updated image uri = "+testimguri);
		  testimg.src = testimguri;
		} catch (e) {
			console.debug(e);
		}

       try {
		  /* these lines are added to parse any dojo widgets in this iWidget */
		  var container = this.iContext.getElementById('@iwName@SpanId');
          dojo.parser.parse(container);
	    } catch (e) {
			console.debug(e);
	    }
    }, 	 


    /*
     * The sendEvent function is called when the Send Data button is pressed. 
     * It fires the TextEntered event which sends a TextEvent.
     */ 
    sendEvent:function(){ 
	  	console.debug("sendEvent in @iwName@.js called") 
        try {
          var data = this.iContext.getElementById(this._uid+"@iwName@DataBox").value;
		  var element = this.iContext.getElementById("@iwName@SentDataSpan");
		  if (element) {
             element.innerHTML = " " + data;
             dojo.addClass(element, "@iwName@-updated");
             dojo.removeClass(this.iContext.getElementById("@iwName@DataSpan"), "@iwName@-updated");
		  }
          console.debug("sendEvent in @iwName@.js firing TextEntered with: "+data) 
          this.iContext.iEvents.fireEvent("TextEntered",null,data); 
		} catch (e) {
			console.debug(e);
		}
    }, 
 	 

    /*
     * The onReceiveEvent function handles the receiving of a TextEvent 
     * when the TextEntered event is fired. It gets the payload and updates display. 
     */ 
	onReceiveEvent:function(iEvent){
 	  	console.debug("onReceiveEvent in @iwName@.js called") 
        try {
		  var data = iEvent.payload;
		  if (typeof data == "undefined" || data == null) {return;} 
 	  	  console.debug("onReceiveEvent in @iwName@.js called data = "+data) 

		  var element = this.iContext.getElementById("@iwName@DataSpan");
		  if (element) {
             element.innerHTML = " " + data;
             dojo.addClass(element, "@iwName@-updated");
             dojo.removeClass(this.iContext.getElementById("@iwName@SentDataSpan"), "@iwName@-updated");
		  }
		} catch (e) {
			console.debug(e);
		}
	},

	lastMethod:function() {
	  	// avoid problem with comma after last method
	} 
});